
#ifndef _GENMAGIC_HPP_
#define _GENMAGIC_HPP_

// Define forced inline
#ifndef INLINE
   #ifdef _MSC_VER
      #define INLINE __forceinline
   #elif defined(__GNUC__)
      #define INLINE __inline__ __attribute__((always_inline))
   #else
      #define INLINE inline
   #endif
#endif


// Define LSB function
#ifdef _MSC_VER
   #if defined(_WIN64) || defined(__LP64__)
	  #include <intrin.h>
      #pragma intrinsic(_BitScanForward64)
	  #define LSB_DEFINED
      
	  INLINE unsigned int LSB(const U64 val)
	  {
		  unsigned int lsb;
		  _BitScanForward64(&lsb, val);
		  return lsb;
	  }
   #endif
#elif defined(__GNUC__) && defined(__LP64__)
   INLINE unsigned int LSB(const U64 val)
   {
      U64 Ret;
      __asm__
      (
         "bsfq %[val], %[Ret]"
         :[Ret] "=r" (Ret)
         :[val] "mr" (val)
      );
      return (unsigned int)Ret;
   }
   #define LSB_DEFINED
#endif

#define IdxToU64(idx)	(1ULL << (idx))

extern const int       lsz64_tbl[64];
extern U64 pawn_attacks[2][64];

/*INLINE int  bitScan (const U64 bb) 
{ 
   const U64 lsb = (bb & -(long long) bb) - 1; 
   const unsigned int foldedLSB = ((int) lsb) ^ ((int) (lsb >> 32)); 
   return lsz64_tbl[foldedLSB * 0x78291ACF >> 26]; 
}*/

INLINE int bitScan(const bitboard & bb) 
{ 
    const bitboard  lsb = (bb & -(long long) bb) - 1; 
    const unsigned int foldedLSB = (unsigned) ((lsb & 0xffffffff) ^ (lsb >> 32)); 
    return lsz64_tbl[foldedLSB * 0x78291ACF >> 26]; 
} 

INLINE unsigned int bitScanAndReset(bitboard & bb)
{ 
    bitboard        b = bb ^ (bb - 1); 
    bb &= (bb - 1); 
    unsigned int    fold = (unsigned) ((b & 0xffffffff) ^ (b >> 32)); 
    return lsz64_tbl[(fold * 0x78291ACF) >> (32 - 6)]; 
} 

#ifndef LSB_DEFINED
#define LSB_DEFINED
	INLINE unsigned int LSB (const bitboard bb)
	{
		return bitScan( bb );
//		return index64[((bb & -bb) * debruijn64) >> 58];
	}
#endif


INLINE unsigned int PopLSB(bitboard * bb)
{
//	return bitScanAndReset( *bb );
	unsigned int lsb = LSB( *bb );
    *bb &= (*bb - 1); 
	return lsb;
}

extern unsigned popCount1(bitboard b);
extern unsigned popCount2(const bitboard b);
#define popCount    popCount2

extern void InitBitboards(void);
extern void convMailboxtoBB(PCON pcon, PSTE pste);

#endif //_GENMAGIC_HPP_