//
//
// Copyright (C) 2007  Harald JOHNSEN
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
//
//

#ifndef _SEARCH_HXX
#define _SEARCH_HXX

// Killer moves, 2 per depth

class _killers {
public:
    void raz(void) {
        Killer1.m = 0;
        Killer2.m = 0;
    }
    void set(const CM *pcm) {
        if( !(Killer1.m == pcm->m ) ) {
            Killer2 = Killer1;
            Killer1 = *pcm;
        }
    }
    CM Killer1;
    CM Killer2;
};
extern _killers Killers[];

class _History {
public:
    _History() {};
    void raz(void) {
        for(int i = 0; i < 64*64; i++)
            hit[i] = 0;
    }
    void update(const CM *cm, int depth) {
        if( cm != NULL )
            hit[ From(cm->m) * To(cm->m) ] += depth*depth;
    }
    int get(const CM *cm) const {
        return hit[ From(cm->m) * To(cm->m) ];
    }
    unsigned int hit[64*64];
};

extern _History History;


#endif // _SEARCH_HXX

